/*
 * PdbIoWrapper.h
 *
 *  Created on: Oct 30, 2012
 *      Author: gpolles
 */

#ifndef PDBIOWRAPPER_H_
#define PDBIOWRAPPER_H_

#include <cstring>
#include <fstream>

class PdbAtomInfo{
public:
  PdbAtomInfo() : serial(0), altloc(' '),
                  chainId(' '), resSeq(0), iCode(' '), x(0.0), y(0.0), z(0.0),
                  occupancy(0.0), tempFactor(0.0) {
    strcpy(name,"");
    strcpy(resName,"");
    strcpy(element,"");
    strcpy(charge,"");
  }
public:
  int serial;
  char name[5];
  char altloc;
  char resName[5];
  char chainId;
  int resSeq;
  char iCode;
  double x,y,z;
  double occupancy;
  double tempFactor;
  char element[3];
  char charge[3];
};

class PdbIoWrapper
{
public:
  PdbIoWrapper();
  virtual ~PdbIoWrapper();

public:
  void openAsInput(const char* fname);
  void openAsOutput(const char* fname);
  void close();

  int parse_pdb_atom_line(char* line, PdbAtomInfo* info);
  void generate_pdb_atom_line(char* line, const PdbAtomInfo& info);

  bool nextAtom(PdbAtomInfo* info);
  bool writeAtom(const PdbAtomInfo& info);


private:
  std::fstream _stream;
  char _line[2000];
  char tmp_buffer[10];

};

#endif /* PDBIOWRAPPER_H_ */
